from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  noexec = 4
  xtrace = 5
  verbose = 6
  noglob = 7
  noclobber = 8
  posix = 9
  vi = 10
  emacs = 11
  interactive = 12
  hashall = 13
  failglob = 14
  extglob = 15
  eval_unsafe_arith = 16
  parse_dynamic_arith = 17
  compat_array = 18
  verbose_errexit = 19
  allow_command_sub = 20
  dynamic_scope = 21
  _running_trap = 22
  nullglob = 23
  inherit_errexit = 24
  strict_argv = 25
  strict_arith = 26
  strict_array = 27
  strict_control_flow = 28
  strict_errexit = 29
  strict_nameref = 30
  strict_word_eval = 31
  strict_tilde = 32
  strict_glob = 33
  parse_at = 34
  parse_brace = 35
  parse_paren = 36
  parse_triple_quoted = 37
  parse_triple_dots = 38
  simple_word_eval = 39
  dashglob = 40
  expand_aliases = 41
  command_sub_errexit = 42
  process_sub_fail = 43
  xtrace_rich = 44
  xtrace_details = 45
  sigpipe_status_ok = 46
  parse_equals = 47
  parse_at_all = 48
  parse_backslash = 49
  parse_backticks = 50
  parse_dollar = 51
  parse_ignored = 52
  parse_amp = 53
  simple_echo = 54
  simple_eval_builtin = 55
  simple_test_builtin = 56
  parse_tea = 57
  lastpipe = 58
  progcomp = 59
  histappend = 60
  hostcomplete = 61
  cmdhist = 62
  assoc_expand_once = 63
  autocd = 64
  cdable_vars = 65
  cdspell = 66
  checkhash = 67
  checkjobs = 68
  checkwinsize = 69
  complete_fullquote = 70
  direxpand = 71
  dirspell = 72
  dotglob = 73
  execfail = 74
  extdebug = 75
  extquote = 76
  force_fignore = 77
  globasciiranges = 78
  globstar = 79
  gnu_errfmt = 80
  histreedit = 81
  histverify = 82
  huponexit = 83
  interactive_comments = 84
  lithist = 85
  localvar_inherit = 86
  localvar_unset = 87
  login_shell = 88
  mailwarn = 89
  no_empty_cmd_completion = 90
  nocaseglob = 91
  nocasematch = 92
  progcomp_alias = 93
  promptvars = 94
  restricted_shell = 95
  shift_verbose = 96
  sourcepath = 97
  xpg_echo = 98
  ARRAY_SIZE = 99

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.pipefail',
  4: 'option.noexec',
  5: 'option.xtrace',
  6: 'option.verbose',
  7: 'option.noglob',
  8: 'option.noclobber',
  9: 'option.posix',
  10: 'option.vi',
  11: 'option.emacs',
  12: 'option.interactive',
  13: 'option.hashall',
  14: 'option.failglob',
  15: 'option.extglob',
  16: 'option.eval_unsafe_arith',
  17: 'option.parse_dynamic_arith',
  18: 'option.compat_array',
  19: 'option.verbose_errexit',
  20: 'option.allow_command_sub',
  21: 'option.dynamic_scope',
  22: 'option._running_trap',
  23: 'option.nullglob',
  24: 'option.inherit_errexit',
  25: 'option.strict_argv',
  26: 'option.strict_arith',
  27: 'option.strict_array',
  28: 'option.strict_control_flow',
  29: 'option.strict_errexit',
  30: 'option.strict_nameref',
  31: 'option.strict_word_eval',
  32: 'option.strict_tilde',
  33: 'option.strict_glob',
  34: 'option.parse_at',
  35: 'option.parse_brace',
  36: 'option.parse_paren',
  37: 'option.parse_triple_quoted',
  38: 'option.parse_triple_dots',
  39: 'option.simple_word_eval',
  40: 'option.dashglob',
  41: 'option.expand_aliases',
  42: 'option.command_sub_errexit',
  43: 'option.process_sub_fail',
  44: 'option.xtrace_rich',
  45: 'option.xtrace_details',
  46: 'option.sigpipe_status_ok',
  47: 'option.parse_equals',
  48: 'option.parse_at_all',
  49: 'option.parse_backslash',
  50: 'option.parse_backticks',
  51: 'option.parse_dollar',
  52: 'option.parse_ignored',
  53: 'option.parse_amp',
  54: 'option.simple_echo',
  55: 'option.simple_eval_builtin',
  56: 'option.simple_test_builtin',
  57: 'option.parse_tea',
  58: 'option.lastpipe',
  59: 'option.progcomp',
  60: 'option.histappend',
  61: 'option.hostcomplete',
  62: 'option.cmdhist',
  63: 'option.assoc_expand_once',
  64: 'option.autocd',
  65: 'option.cdable_vars',
  66: 'option.cdspell',
  67: 'option.checkhash',
  68: 'option.checkjobs',
  69: 'option.checkwinsize',
  70: 'option.complete_fullquote',
  71: 'option.direxpand',
  72: 'option.dirspell',
  73: 'option.dotglob',
  74: 'option.execfail',
  75: 'option.extdebug',
  76: 'option.extquote',
  77: 'option.force_fignore',
  78: 'option.globasciiranges',
  79: 'option.globstar',
  80: 'option.gnu_errfmt',
  81: 'option.histreedit',
  82: 'option.histverify',
  83: 'option.huponexit',
  84: 'option.interactive_comments',
  85: 'option.lithist',
  86: 'option.localvar_inherit',
  87: 'option.localvar_unset',
  88: 'option.login_shell',
  89: 'option.mailwarn',
  90: 'option.no_empty_cmd_completion',
  91: 'option.nocaseglob',
  92: 'option.nocasematch',
  93: 'option.progcomp_alias',
  94: 'option.promptvars',
  95: 'option.restricted_shell',
  96: 'option.shift_verbose',
  97: 'option.sourcepath',
  98: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  read = 20
  echo = 21
  printf = 22
  mapfile = 23
  readarray = 24
  cd = 25
  pushd = 26
  popd = 27
  dirs = 28
  pwd = 29
  source = 30
  umask = 31
  wait = 32
  jobs = 33
  fg = 34
  bg = 35
  shopt = 36
  complete = 37
  compgen = 38
  compopt = 39
  compadjust = 40
  getopts = 41
  command = 42
  type = 43
  hash = 44
  help = 45
  history = 46
  alias = 47
  unalias = 48
  bind = 49
  push = 50
  write = 51
  json = 52
  pp = 53
  use = 54
  opts = 55
  fopen = 56
  run = 57
  fork = 58
  forkwait = 59
  push_registers = 60
  cat = 61
  ARRAY_SIZE = 62

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.read',
  21: 'builtin.echo',
  22: 'builtin.printf',
  23: 'builtin.mapfile',
  24: 'builtin.readarray',
  25: 'builtin.cd',
  26: 'builtin.pushd',
  27: 'builtin.popd',
  28: 'builtin.dirs',
  29: 'builtin.pwd',
  30: 'builtin.source',
  31: 'builtin.umask',
  32: 'builtin.wait',
  33: 'builtin.jobs',
  34: 'builtin.fg',
  35: 'builtin.bg',
  36: 'builtin.shopt',
  37: 'builtin.complete',
  38: 'builtin.compgen',
  39: 'builtin.compopt',
  40: 'builtin.compadjust',
  41: 'builtin.getopts',
  42: 'builtin.command',
  43: 'builtin.type',
  44: 'builtin.hash',
  45: 'builtin.help',
  46: 'builtin.history',
  47: 'builtin.alias',
  48: 'builtin.unalias',
  49: 'builtin.bind',
  50: 'builtin.push',
  51: 'builtin.write',
  52: 'builtin.json',
  53: 'builtin.pp',
  54: 'builtin.use',
  55: 'builtin.opts',
  56: 'builtin.fopen',
  57: 'builtin.run',
  58: 'builtin.fork',
  59: 'builtin.forkwait',
  60: 'builtin.push_registers',
  61: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

